<template>
  <a-spin :spinning="confirmLoading">
    <a-form ref="formRef" class="antd-modal-form" :labelCol="labelCol" :wrapperCol="wrapperCol">
      <a-row>
        <a-col :span="24">
          <a-form-item label="当前地址" v-bind="validateInfos.url">
	          <a-textarea v-model:value="formData.url" rows="4" placeholder="请输入当前地址" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="当前地址类型" v-bind="validateInfos.typeUrl">
            <a-input v-model:value="formData.typeUrl" placeholder="请输入当前地址类型" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="当前地址状态" v-bind="validateInfos.stateUrl">
            <a-input v-model:value="formData.stateUrl" placeholder="请输入当前地址状态" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="父地址" v-bind="validateInfos.source">
	          <a-textarea v-model:value="formData.source" rows="4" placeholder="请输入父地址" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="父地址类型" v-bind="validateInfos.typeSource">
            <a-input v-model:value="formData.typeSource" placeholder="请输入父地址类型" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="父地址状态" v-bind="validateInfos.stateSource">
            <a-input v-model:value="formData.stateSource" placeholder="请输入父地址状态" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="信息" v-bind="validateInfos.message">
	          <a-textarea v-model:value="formData.message" rows="4" placeholder="请输入信息" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="主站点链接" v-bind="validateInfos.mainUrl">
	          <a-textarea v-model:value="formData.mainUrl" rows="4" placeholder="请输入主站点链接" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="创建时间" v-bind="validateInfos.saveTime">
		        <a-date-picker placeholder="请选择创建时间" v-model:value="formData.saveTime" value-format="YYYY-MM-DD"  style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="更新时间" v-bind="validateInfos.updateTime">
		        <a-date-picker placeholder="请选择更新时间" v-model:value="formData.updateTime" value-format="YYYY-MM-DD"  style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
      </a-row>
    </a-form>
  </a-spin>
</template>

<script lang="ts" setup>
  import { ref, reactive, defineExpose, nextTick, defineProps, computed, onMounted } from 'vue';
  import { defHttp } from '/@/utils/http/axios';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { getValueType } from '/@/utils';
  import { saveOrUpdate } from '../ExternalInternalSite.api';
  import { Form } from 'ant-design-vue';
  
  const props = defineProps({
    formDisabled: { type: Boolean, default: false },
    formData: { type: Object, default: ()=>{} },
    formBpm: { type: Boolean, default: true }
  });
  const formRef = ref();
  const useForm = Form.useForm;
  const emit = defineEmits(['register', 'ok']);
  const formData = reactive<Record<string, any>>({
    id: '',
    url: '',   
    typeUrl: '',   
    stateUrl: '',   
    source: '',   
    typeSource: '',   
    stateSource: '',   
    message: '',   
    mainUrl: '',   
    saveTime: '',   
    updateTime: '',   
  });
  const { createMessage } = useMessage();
  const labelCol = ref<any>({ xs: { span: 24 }, sm: { span: 5 } });
  const wrapperCol = ref<any>({ xs: { span: 24 }, sm: { span: 16 } });
  const confirmLoading = ref<boolean>(false);
  //表单验证
  const validatorRules = {
    url: [{ required: true, message: '请输入当前地址!'},],
    typeUrl: [{ required: true, message: '请输入当前地址类型!'},],
    stateUrl: [{ required: true, message: '请输入当前地址状态!'},],
    source: [{ required: true, message: '请输入父地址!'},],
    typeSource: [{ required: true, message: '请输入父地址类型!'},],
    stateSource: [{ required: true, message: '请输入父地址状态!'},],
    message: [{ required: true, message: '请输入信息!'},],
    mainUrl: [{ required: true, message: '请输入主站点链接!'},],
    saveTime: [{ required: true, message: '请输入创建时间!'},],
    updateTime: [{ required: true, message: '请输入更新时间!'},],
  };
  const { resetFields, validate, validateInfos } = useForm(formData, validatorRules, { immediate: true });

  // 表单禁用
  const disabled = computed(()=>{
    if(props.formBpm === true){
      if(props.formData.disabled === false){
        return false;
      }else{
        return true;
      }
    }
    return props.formDisabled;
  });

  
  /**
   * 新增
   */
  function add() {
    edit({});
  }

  /**
   * 编辑
   */
  function edit(record) {
    nextTick(() => {
      resetFields();
      //赋值
      Object.assign(formData, record);
    });
  }

  /**
   * 提交数据
   */
  async function submitForm() {
    // 触发表单验证
    await validate();
    confirmLoading.value = true;
    const isUpdate = ref<boolean>(false);
    //时间格式化
    let model = formData;
    if (model.id) {
      isUpdate.value = true;
    }
    //循环数据
    for (let data in model) {
      //如果该数据是数组并且是字符串类型
      if (model[data] instanceof Array) {
        let valueType = getValueType(formRef.value.getProps, data);
        //如果是字符串类型的需要变成以逗号分割的字符串
        if (valueType === 'string') {
          model[data] = model[data].join(',');
        }
      }
    }
    await saveOrUpdate(model, isUpdate.value)
      .then((res) => {
        if (res.success) {
          createMessage.success(res.message);
          emit('ok');
        } else {
          createMessage.warning(res.message);
        }
      })
      .finally(() => {
        confirmLoading.value = false;
      });
  }


  defineExpose({
    add,
    edit,
    submitForm,
  });
</script>

<style lang="less" scoped>
  .antd-modal-form {
    min-height: 500px !important;
    overflow-y: auto;
    padding: 24px 24px 24px 24px;
  }
</style>
